import ProductData from "@comp/AppsComponent/ProductData/page";

async function getData(id) {
  const res = await fetch(`${process.env.NEXT_PUBLIC_API_URL}/product/${id}`);
  const post = await res.json();
  return post;
}

export async function generateMetadata({ params }) {
  const data = await getData(params.id[0]);

  const decodedName = decodeURIComponent(params.id[1]);

  console.log("dddddd", data?.product);

  return {
    title: decodedName,
    description: `  خرید ${decodedName}| برندهای متنوع با پایین ترین قیمت | فروشگاه اینترنتی وسمه`,
    metadataBase: new URL(
      `https://www.vesmeh.com/categories/${params.id[0]}/${decodedName}`
    ),
    product_id_meta: data?.product?.id,
    keywords: [
      "آرایشی",
      "بهداشت خانگی",
      "محصولات زیبایی",
      "لوازم تمیزی",
      "مراقبت شخصی",
    ],
    openGraph: {
      title: decodedName,
      description: `  خرید ${decodedName}| برندهای متنوع با پایین ترین قیمت | فروشگاه اینترنتی وسمه`,
      url: `https://www.vesmeh.com/categories/${params.id[0]}/${decodedName}`,
      type: "website",

      images: [
        {
          url: JSON.stringify(
            process.env.NEXT_PUBLIC_STORAGE_URL + "/" + data?.product?.files &&
              data?.product?.files[0].fileLocation
          ), // Dynamic og route
          width: 800,
          height: 600,
        },
      ],
      locale: "en_US",
      type: "website",
    },
    twitter: {
      site: "@vesmehstore",
      description: `  خرید ${decodedName}| برندهای متنوع با پایین ترین قیمت | فروشگاه اینترنتی وسمه`,
      title: decodedName,
      creator: "@vesmehstore",
    },
    other: {
      product_id: data?.product?.id,
      product_name: data?.product?.persianName,
      product_price: data?.product?.costWithDiscount,
      product_old_price: data?.product?.cost,
      availability: data?.product?.stock > 0 ? "instock" : "outofstock",
      guarantee: "guarantee_sample",
    },
  };
}

const Page = async ({ params }) => {
  const data = await getData(params.id[0]);

  return (
    <>
      <ProductData params={params} data={data} />
    </>
  );
};

export default Page;
